      subroutine calcmsd
      use variables
      use constants
      double precision :: rxp, ryp, rzp

!      rxd=rxd+rx-rxp; ryd=ryd+ry-ryp; rzd=rzd+rz-rzp
      do i=1,n
         rxp = hmat(1,1)*qpx(i)+hmat(1,2)*qpy(i)+hmat(1,3)*qpz(i)
         ryp = hmat(2,1)*qpx(i)+hmat(2,2)*qpy(i)+hmat(2,3)*qpz(i)
         rzp = hmat(3,1)*qpx(i)+hmat(3,2)*qpy(i)+hmat(3,3)*qpz(i)
         rxd(i)=rxd(i)+rx(i)-rxp; ryd(i)=ryd(i)+ry(i)-ryp; rzd(i)=rzd(i)+rz(i)-rzp
      enddo

      cgrx=0.0d0; cgry=0.0d0; cgrz=0.0d0
      do i=1,n
         cgrx=cgrx+rxd(i); cgry=cgry+ryd(i); cgrz=cgrz+rzd(i)
      enddo
      cgrx=cgrx/dble(n); cgry=cgry/dble(n); cgrz=cgrz/dble(n)
      msdx=0.0d0; msdy=0.0d0; msdz=0.0d0
      msdxc=0.0d0; msdyc=0.0d0; msdzc=0.0d0
      do i=1,n
!         msdx=msdx+rxd(i)**2; msdy=msdy+ryd(i)**2; msdz=msdz+rzd(i)**2
         msdxc=msdxc+(rxd(i)-cgrx)**2; msdyc=msdyc+(ryd(i)-cgry)**2; msdzc=msdzc+(rzd(i)-cgrz)**2
         msdx=msdx+rxd(i)**2; msdy=msdy+ryd(i)**2; msdz=msdz+rzd(i)**2
      enddo
      msdx=msdx/dble(n); msdy=msdy/dble(n); msdz=msdz/dble(n)
      msdxc=msdxc/dble(n); msdyc=msdyc/dble(n); msdzc=msdzc/dble(n)

      end
