      subroutine out
      use variables
      use constants
      implicit double precision (a-h,o-z)
      
      if (potential_func=='Shellmodel') then
         do k=1,n/2
            a1=0.0d0
            a2=0.0d0
            a3=0.0d0
            if (qx(k).gt.1.0) a1=-1.0d0
            if (qx(k).lt.0.0) a1=1.0d0
            if (qy(k).gt.1.0) a2=-1.0d0
            if (qy(k).lt.0.0) a2=1.0d0
            if (qz(k).gt.1.0) a3=-1.0d0
            if (qz(k).lt.0.0) a3=1.0d0
            if (.not.pbcx) a1=0.0d0
            if (.not.pbcy) a2=0.0d0
            if (.not.pbcz) a3=0.0d0
            ! modify core positions
            qx(k)=qx(k)+a1
            qy(k)=qy(k)+a2
            qz(k)=qz(k)+a3
            rx(k)=rx(k)+hmat(1,1)*a1+hmat(1,2)*a2+hmat(1,3)*a3
            ry(k)=ry(k)+hmat(2,1)*a1+hmat(2,2)*a2+hmat(2,3)*a3
            rz(k)=rz(k)+hmat(3,1)*a1+hmat(3,2)*a2+hmat(3,3)*a3
            ! modify corresponding shell
            qx(k+n/2)=qx(k+n/2)+a1
            qy(k+n/2)=qy(k+n/2)+a2
            qz(k+n/2)=qz(k+n/2)+a3
            rx(k+n/2)=rx(k+n/2)+hmat(1,1)*a1+hmat(1,2)*a2+hmat(1,3)*a3
            ry(k+n/2)=ry(k+n/2)+hmat(2,1)*a1+hmat(2,2)*a2+hmat(2,3)*a3
            rz(k+n/2)=rz(k+n/2)+hmat(3,1)*a1+hmat(3,2)*a2+hmat(3,3)*a3
         enddo
      else
         do k=1,n
            a1=0.0d0
            a2=0.0d0
            a3=0.0d0
            if (qx(k).gt.1.0) a1=-1.0d0
            if (qx(k).lt.0.0) a1=1.0d0
            if (qy(k).gt.1.0) a2=-1.0d0
            if (qy(k).lt.0.0) a2=1.0d0
            if (qz(k).gt.1.0) a3=-1.0d0
            if (qz(k).lt.0.0) a3=1.0d0
            if (.not.pbcx) a1=0.0d0
            if (.not.pbcy) a2=0.0d0
            if (.not.pbcz) a3=0.0d0
            qx(k)=qx(k)+a1
            qy(k)=qy(k)+a2
            qz(k)=qz(k)+a3
            rx(k)=rx(k)+hmat(1,1)*a1+hmat(1,2)*a2+hmat(1,3)*a3
            ry(k)=ry(k)+hmat(2,1)*a1+hmat(2,2)*a2+hmat(2,3)*a3
            rz(k)=rz(k)+hmat(3,1)*a1+hmat(3,2)*a2+hmat(3,3)*a3
         enddo
      endif

      end
